import importlib

if "bpy" in locals():
    importlib.reload(operators)
else:
    from . import (operators)


import bpy
from bpy.types import Panel, UIList
from . import bl_info



def glared_panel(self, context):
    scene = context.scene
    layout = self.layout



    glared = "Glared"

    layout = self.layout
    row = layout.row()
    row.operator(operators.SCENE_OT_Glared_RealtimeFX.bl_idname, text="Add Realtime FX")
    row = layout.row()
    row.operator(operators.SCENE_OT_Glared_RemoveRealtimeFX.bl_idname, text="Remove Realtime FX")

    preferences = context.preferences.addons[__package__].preferences




    if scene.node_tree:
        nodes = scene.node_tree.nodes

        if glared in nodes:
            if 'lensflarecyclesvisibility' in context.window_manager.rna_type.properties:
                if not context.window_manager.lensflarecyclesvisibility and not preferences.multy_scene_warning:
                    box = layout.box()

                    col = box.column(align=True)
                    col.alert = True
                    col.label(text="WARNING: ")
                    col.alert = False

                    col.label(text="There’s an incompatibility between  ")
                    col.label(text="Glared and the Flared function")
                    col.label(text="to Force Eevee on a New Layer")
                    row = box.row(align=True)
                    op = row.operator(
                        'wm.url_open',
                        text='Online docs',
                        icon='URL'
                    )
                    op.url = 'https://www.blenderlensflare.com/portfolio-items/incompatibility-between-glared-and-flared/'
                    row = box.row(align=True)
                    row.prop(preferences, "multy_scene_warning")

            if not preferences.glare_alert:
                box = layout.box()

                col = box.column(align=True)
                col.alert = True
                col.label(text="WARNING: ")
                col.alert = False

                col.label(text="Realtime FX require some extra settings.")
                col.label(text="Check the online documentation to properly")
                col.label(text="set up Blender, otherwise you may not be ")
                col.label(text="able to see the effects correctly")
                row = box.row(align=True)
                op = row.operator(
                    'wm.url_open',
                    text='Online docs',
                    icon='URL'
                )
                op.url = 'https://www.blenderlensflare.com/portfolio-items/glared-realtime-fx/'
                row = box.row(align=True)
                row.prop(preferences, "glare_alert")

            glared_node = nodes[glared]
            row = layout.row()
            row.prop(scene.glaredglobalprop, "active_fx_glared", text="Activate FX")

            i = 0
            from . import SCENE_MT_GlaredPresetsComposite
            row = layout.row()
            active_preset = SCENE_MT_GlaredPresetsComposite.bl_label
            row.menu('SCENE_MT_GlaredPresetsComposite', text=active_preset)
            row.operator('glared.add_preset_composite', text='', icon='ADD').name = "GlaredPreset"
            row.operator("scene.glared_popup_remove_preset", icon='REMOVE', text="").field = 'PRESETCOMPOSITE'

            row = layout.column(align=True)
            # row.prop(scene.lensflareglobalprop, "prop1")

            light_boost = glared_node.node_tree.nodes['Bright/Contrast']

            for input in glared_node.inputs:

                if input.name == "Image":
                    continue
                if i == 0:
                    col = row.column(align=True)
                    col.prop(light_boost, "mute", text="Light Boost", emboss=True, toggle=1, invert_checkbox=True)
                    #col.prop(scene.glaredglobalprop, "light_boost", emboss=True, toggle=1)
                if i == 1 or i == 5 or i == 10 or i == 14 or i == 15 or i == 16 or i == 22:
                    # layout.split()
                    # print("row")

                    row = layout.column(align=True)

                col = row.column(align=True)

                # print("col")
                col.enabled = not glared_node.mute
                col.prop(input, "default_value", text=input.name)

                i += 1



class PANEL_PT_glared(Panel):




    v = bl_info["version"]

    version = str(v[0]) + "." + str(v[1]) + "." + str(v[2])
    """Glared"""
    bl_label = "Glared "+version
    bl_idname = "PANEL_PT_lensflare_glared"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "Glared"
    #bl_options = {'DEFAULT_CLOSED'}



    def draw(self, context):
        glared_panel(self, context)
